Con                          'display picture from Parallax laser range finder to 4D systems ulcd
                                                           
  _CLKMODE = XTAL1 + PLL16X                              
  _XINFREQ = 5_000_000
  
  ACK = 6
  LCD_RX = 17  'input from lcd transmit pin
  LCD_TX = 16  'output to lcd receive pin
  LRF_RX = 15  'input from laser range finder transmit pin
  LRF_TX = 14  'output to laser range finder receive pin
  
Var

  byte buffer[20480]
  
Obj

  lcd : "fullduplexserial"
  lrf : "fullduplexserialplus" 
       
Pub Main
  
  lcd.start(LCD_RX, LCD_TX, 0, 115200)   
  lrf.start(LRF_RX, LRF_TX, 0, 115200)
  
  clear_screen
  put_string(@splash)
  
  lrf.tx("U")
  repeat until lrf.rx == ":"
  
  lrf.tx("E")
  repeat until lrf.rx == ":"
  
  clear_screen
  display_frame

Pub Clear_Screen

  lcd.tx($ff)
  lcd.tx($cd)
  repeat until lcd.rx == ACK

Pub Display_Frame | i, r, g, b, x, y

  lrf.tx("G")
  
  i := 0
  repeat
    buffer[i++] := lrf.rx
    if i > 20480
      repeat until lrf.rx == ":"
      quit
 
  i := 0
  repeat y from 0 to 127
    repeat x from 0 to 159
      r := g := b := buffer[i++]
      put_pixel(x, y, r, g, b)
  waitcnt(clkfreq/100 + cnt)    
  lcd.rxflush
    
Pub Put_Pixel(x, y, r, g, b) | color                                         
                                               
  color := r >> 3 << 11 | g >> 2 << 5 | b >> 3 
  lcd.tx($ff)                                  
  lcd.tx($c1)                                  
  lcd.tx(x >> 8)                               
  lcd.tx(x)                                    
  lcd.tx(y >> 8)                               
  lcd.tx(y)                                    
  lcd.tx(color >> 8)                           
  lcd.tx(color)                                

Pub Put_String(str)

  lcd.tx($00)
  lcd.tx($18)
  lcd.str(str)
  lcd.tx($00)
  repeat until lcd.rx == ACK

Dat

Splash  byte  "Please wait for camera to",13,10,13,10,"   setup & take picture",0                                        